import matplotlib.pyplot as plt
import math

def g(T, X, Z):
	
	return Z

######### second order diferencial equation declaration ###############

def f(T, X, Z):
	L= 0.3
	C=0.000020

	return  - Z/(L*C) 

############ RK4 method #############################

def RK4(x0, t0, z0, h , n):
	x= [x0]
	t= [t0]
	z= [z0]

	i=1
	print(x[0])
	for i in range(1,n-1):
		t.append((t[i-1]+h))

		k1= g(t[i-1], x[i-1], z[i-1])
		l1= f(t[i-1], x[i-1], z[i-1])

		k2= g(t[i-1] + h/2, x[i-1] + h/2, z[i-1] + h/2)
		l2= f(t[i-1] + h/2, x[i-1] + h/2, z[i-1] + h/2)

		k3= g(t[i-1] + h/2, x[i-1]+ (h/2)*k2, z[i-1]+ (h/2)*k2)
		l3= f(t[i-1] + h/2, x[i-1]+ (h/2)*k2, z[i-1]+ (h/2)*k2)

		k4= g(t[i-1]+ h, x[i-1]+ h*k3, z[i-1]+ h*k3)
		l4= f(t[i-1]+ h, x[i-1]+ h*k3, z[i-1]+ h*k3)


		x.append(x[i-1] + (h/6)*(k1 + 2*k2 + 2*k3 + k4))
		z.append(z[i-1] + (h/6)*(l1 + 2*l2 + 2*l3 + l4))
		

	
 	return x,t, z

####### Initial Conditions ####################

x0= 10
t0= 0
z0=2
h=0.00001
n= 20000
x, t,z=  RK4(x0, t0, z0, h, n)

######### Plots #################################

plt.plot(t,x)
plt.plot((0,0.2), (10,10))
plt.xlabel("t")
plt.ylabel("x(t)")
plt.show()
