import matplotlib.pyplot as plt
import math

######### diferencial equation declaration ###############

def dxdt(T, X):
	R=5
	C= 1
	f= -X/(C*R)
	return f

############ RK4 method #############################

def RK4(fx, x0, t0, h , n):
	x= []
	t= []
	i=1
	t.append(t0)
	x.append(x0)
	x[0]= x0
	for i in range(1,n-1):
		t.append((t[i-1]+h))
		k1= fx(t[i-1], x[i-1])
		k2= fx(t[i-1] + h/2, x[i-1] + h/2)
		k3= fx(t[i-1] + h/2, x[i-1]+ (h/2)*k2)
		k4= fx(t[i-1]+ h, x[i-1]+ h*k3)
		x.append(x[i-1] + (h/6)*(k1 + 2*k2 + 2*k3 + k4))
 	return x,t

####### Initial Conditions ####################

x0= 10
t0= 0
h=0.1
n= 400
x, t=  RK4(dxdt, x0, t0, h, n)

######### Plots #################################

plt.plot(t,x)
plt.xlabel("t")
plt.ylabel("x(t)")
plt.show()










